#!/usr/bin/perl -w
# scripted by JoungKyun Kim <http://www.oops.org>
# This script follow BPL License

# major version number of procps
local $procps = 2;

local $target = "";
local $report = "";
local @reports = ();

if ( $#ARGV < 0 ) {
  $target = "cpu";
} else {
  $target = "$ARGV[0]";
}

if ( $target ne "cpu" || $target eq "single") {
  if ( $procps == 3 ) {
    $NUM = 1;
    $FORMATS = "\$2\" \"\$4\" \"\$8";
  } else {
    $NUM = 0;
    $FORMATS = "\$3\" \"\$5\" \"\$9";
  }

  if ($target eq "single") { $target = "cpu"; }
  $report = `/usr/bin/top -b -n $NUM | /bin/grep -i "^${target}" | /bin/awk '{print $FORMATS}' | /bin/sed 's/%//g'`;

  @reports = split(/[\s]/, $report);

  foreach $line (@reports) {
    print "$line\n";
  }
} else {
  if ( $procps == 3 ) {
    $NUM = 1;
    $FORMATS = "\$2\" \"\$4\" \"\$8\" \"\$12\" \"\$14\" \"\$18";
  } else {
    $NUM = 0;
    $FORMATS = "\$3\" \"\$5\" \"\$9\" \"\$13\" \"\$15\" \"\$19";
  }

  $report = `/usr/bin/top -b -n $NUM | /bin/grep -i "^cpu[0-9]" | /bin/awk '{print $FORMATS}' | /bin/sed 's/%//g'`;
  $report =~ s/[\s]+/ /g;
  @reports = split(/[\s]/, $report);

  my $user = ($reports[0] + $reports[3]) / 2;
  my $system = ($reports[1] + $reports[4]) / 2;
  my $idle = ($reports[2] + $reports[5]) / 2;
  
  print "$user\n$system\n$idle\n";
}

exit 0

